% v3.0. Not returning cb, cs and Tc.
function [Ms, Reconstr]=CIE_Method2(im,mask,Cb,Cs)

    indx=find(mask);
    r=im(:,:,1);
    g=im(:,:,2);
    b=im(:,:,3);
    imRGB=[r(indx) g(indx) b(indx)];

    error=10^10;
    for s=1:size(Cs,1)
        [mbx msx]=solveMbMsPositive(imRGB,Cb(1,:).*Cs(s,:)./norm(Cb(1,:).*Cs(s,:))*255,Cs(s,:));
        recon = mbx' * (Cb(1,:).*Cs(s,:)./norm(Cb(1,:).*Cs(s,:))*255) + msx' * Cs(s,:);
        eReconst=sum(sum((imRGB-recon).^2))/size(im(:),1);

        if eReconst<error
            Msx=msx;
            error=eReconst;
            ReconX=recon;
        end
    end
    Ms=zeros(size(im,1),size(im,2));
    Ms(indx)=Msx';
    Reconstr=zeros(size(im,1)*size(im,2),3);
    Reconstr(indx,:)=ReconX;
    Reconstr=reshape(Reconstr,size(im,1),size(im,2),3);

end
